// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/types.h>

#include "target.h"
#include "pixelflood.h"

class target_pixelflood : public target
{
private:
	const int quality;
	const std::string host;
	const int port;
	resize *const r;
	const int pw, ph;
	const pixelflood_protocol_t pp;
	const int xoff, yoff;

	int fd;
	struct sockaddr_in servaddr;

	bool send_frame(const uint8_t *const data, const int w, const int h);

public:
	target_pixelflood(const std::string & id, const std::string & descr, source *const s, const double interval, const std::vector<filter *> *const filters, const double override_fps, configuration_t *const cfg, const std::string & ip_addr, const int port, resize *const r, const int pfw, const int pfh, const int quality, const pixelflood_protocol_t pp, const int xoff, const int yoff, const bool use_previous_when_fail);
	virtual ~target_pixelflood();

	void operator()() override;
};
